TITLE	VSCrypt.asm

.486
.model flat, stdcall      ; memory model & calling convention
option casemap :none      ; case sensitive

.code
VSCrypt proc public uses esi edi mode:dword, inString:dword, outString:dword
	mov	esi, [inString]
	mov	edi, [outString]	

	mov	al, byte ptr [esi]
	test	al, al
	je		short Done
	
; set up the crypt value
	mov	edx, [mode]
	sub	edx, 2
	neg	edx
	sbb	edx, edx
	and	edx, 00003ebf4h
	add	edx, 0fffe0a06h

align 4	
@@:
	add	al, dl
	add	esi, 1
	mov	byte ptr [edi], al
	mov	al, byte ptr [esi]
	add	edi, 1
	test	al, al
	jne	@B
	
Done:
	; copy over the NULL terminator into the desination buffer
	mov	byte ptr [edi], al

	ret
VSCrypt endp


END
