TITLE "Gets an element from the array by index value"

.586
.model flat			; memory model
option casemap:none	; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_faArray.inc


.code

; ----------------------------------------------------------------------------
; prototype:
; LPVOID __stdcall faGetElementByIndex(ArrayObject* Object, const LONG Index);
; ----------------------------------------------------------------------------
align 16
_faGetElementByIndex@8 proc public
	; check our parameters
	push 1
	push [esp+12]	;	Index parameter
	push [esp+12]	;	Object parameter
	call faCheckParameters

	; check function result	
	test eax, eax
	je Success
	
	xor	eax, eax
	ret	8
	
Success:
	; get the params
	mov edx, [esp + 8]
	mov eax, [esp + 4]
	
	; get the address of the index
	mov	ecx, [eax].ArrayObject.Array
	mov	eax, [ecx+edx*4]

	ret	8
_faGetElementByIndex@8 ENDP

END
