TITLE "sorts the array based on user-define compare"

.586
.model flat			; memory model
option casemap:none	; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_faArray.inc
include asm_Analysis.inc


.code

; ----------------------------------------------------------------------------
; prototype:
; LONG __stdcall faSortElements(ArrayObject* pObject, int (__stdcall *comp)(const void *, const void *));
; ----------------------------------------------------------------------------
align 16
_faSortElements@8 proc public
	; save the ESI register
	push	esi
	mov	esi, [esp+8]	; object parameter
	
	; check our params
	xor	eax, eax
	push	eax
	push	eax
	push	esi
	call  faCheckParameters
	
	; check result
	test	eax, eax
	jne	@F

	; sort the array
	push	[esp+12]	; comp routine
	push	[esi].ArrayObject.Count
	push	[esi].ArrayObject.Array
	call	QuickSort
	
	; set the status to AO_SUCCESS
	xor	eax, eax

@@:
	pop	esi
	ret 8
_faSortElements@8 ENDP

END
