TITLE "Converts a time_t to a FileTime data type"

.586
.model flat, stdcall	; memory model
option casemap:none	    ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Kernel32.inc

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
; (none)


.code
; ----------------------------------------------------------------------------
; prototype:
;    void __stdcall BinarySearch(const time_t tTime, FILETIME* pFileTime);
;
; Description:
;   Converts a time_t type data into a FILETIME data type.
;
; Returns:
;   (none)
; ============================================================================
align 16
_TimeTtoFileTime@8 PROC NEAR
	mov	edx, 10000000
	mov	eax, [esp + 4]
	mov	ecx, [esp + 8]
	
	mul	edx
	
	add	eax, 0e53e8000h
	adc	edx, 019db1deh
	
	mov	[ecx].FILETIME.dwLowDateTime, eax
	mov	[ecx].FILETIME.dwHighDateTime, edx
	
	ret 8
_TimeTtoFileTime@8 ENDP

END
