@ECHO OFF

REM ---------------------------------------------------------
REM  Clean the .OBJ and .SBR files from the DEBUG directory.
REM ---------------------------------------------------------
IF EXIST Debug\*.obj @ECHO Cleaning .obj files from the Debug directory
IF EXIST Debug\*.obj DEL Debug\*.obj
IF EXIST Debug\*.sbr @ECHO Cleaning .sbr files from the Debug directory
IF EXIST Debug\*.sbr DEL Debug\*.sbr

REM ----------------------------------------------------
REM  Build the ANSI debug code version of the ASM files.
REM --------------------------------------------------
CD Debug
IF EXIST ..\*.asm @CALL \asm\d.bat ..\*
IF EXIST ..\ANSI\*.asm @CALL \asm\d.bat ..\ANSI\*

IF EXIST *.obj \masm32\bin\polib.exe /out:%1.lib *.obj

REM ----------------------------------------------------
REM  Change back to the starting directory where this
REM  batch from was called from to keep our directory
REM  navigation in tack in case other batch files will
REM  be called.
REM ----------------------------------------------------
CD ..

@ECHO.
