; ****************************************************************************
;   This file contains all defines (equates), structures and ANSI/UNICODE
;   function prototypes for the 'Strings' library. ANSI or UNICODE specific
;   function prototypes are defined in their respective .INC file.
;
;   You may use or modify this code freely without any restrictions.
;
;   v1.0 - Initial coding of the file   Oct 10, 2006  4:00 PM
; ****************************************************************************

; ----------------------------------------------------------------------------
; Strings library specific defines and global variables
; ============================================================================
StringCaseLower     equ 0h
StringCaseUpper     equ 1h


; ----------------------------------------------------------------------------
; Functions from other "asm" libraries
; ============================================================================


; ----------------------------------------------------------------------------
; Function definitions --- ANSI/UNICODE non-specific
; ============================================================================


; ----------------------------------------------------------------------------
; Function definitions --- ANSI or UNICODE based on define during assembling
; ============================================================================
IF _UNICODE eq 1	; same definition as the MFC library (windows API uses UNICODE)
	include unicode\asm_Strings.inc
ELSE
	include ansi\asm_Strings.inc
ENDIF
