.686
.xmm
.model flat, stdcall      ; memory model & calling convention
option casemap :none      ; case sensitive


.code
; ********** ReadClock function **********
; C++ prototype:
; extern "C" int ReadClock (void);

; This function returns the value of the time stamp counter, which counts 
; clock cycles. To count how many clock cycles a piece of code takes, call
; Rdtsc before and after the code to measure and calculate the difference.
; The function itself takes approximately 700 clock cycles on a Pentium 4,
; and approximately 225 clock cycles on Pentium II and Pentium III. 
; Does not work on 80386 and 80486.
align 16

ReadClock proc public uses ebx
	xor	eax, eax
	cpuid                ; serialize
	rdtsc                ; read time stamp counter
	push	eax
	xor	eax, eax
	cpuid                ; serialize
	pop	eax
	ret
ReadClock ENDP

END
