.486
.model flat


.code

; ---------------------------------------------------------------------------
; Description:
;		A very quick function to convert a double precision floating point
;		number to an integer, rounding to the nearest or even whole number.
;		Does not check for overflow.
;
; NOTE:
;		This function is *much* faster then the default conversion method in
;		C/C++ which uses truncation.
;
; Returns:
;		A whole number rounded to the nearest or even number.
; ---------------------------------------------------------------------------
align 16

_Round@8 proc public
	fld	qword ptr [esp+4]
	sub	esp, 4
	fistp	dword ptr [esp]
	pop	eax
	ret
_Round@8 ENDP


END
