TITLE	inftrees.asm
.586
.model flat


include asm_Zip.inc


.const
align 8
_lbase DD 003H, 004H, 005H, 006H, 007H, 008H, 009H, 00aH
       DD 00bH, 00dH, 00fH, 011H, 013H, 017H, 01bH, 01fH
       DD 023H, 02bH, 033H, 03bH, 043H, 053H, 063H, 073H
       DD 083H, 0a3H, 0c3H, 0e3H, 0102H,000H, 000H, 000H

_lext	 DD 010H, 010H, 010H, 010H, 010H, 010H, 010H, 010H
       DD 011H, 011H, 011H, 011H, 012H, 012H, 012H, 012H
       DD 013H, 013H, 013H, 013H, 014H, 014H, 014H, 014H
       DD 015H, 015H, 015H, 015H, 010H, 04cH, 042H, 000H
       
_dbase DD 001H, 002H, 003H, 004H, 005H, 007H, 009H, 00dH
       DD 011H, 019H, 021H, 031H, 041H, 061H, 081H, 0c1H
       DD 00101H, 00181H, 00201H, 00301H, 00401H, 00601H, 0801H, 0c01H
       DD 01001H, 01801H, 02001H, 03001H, 04001H, 06001H, 0000H, 000H
       
_dext  DD 010H, 010H, 010H, 010H, 011H, 011H, 012H, 012H
       DD 013H, 013H, 014H, 014H, 015H, 015H, 016H, 016H
       DD 017H, 017H, 018H, 018H, 019H, 019H, 01aH, 01aH
       DD 01bH, 01bH, 01cH, 01cH, 01dH, 01dH, 040H, 040H
       

.data
_TEXT	SEGMENT
_c$ = -1352						; size = 4
_root$ = -1348						; size = 4
_drop$ = -1344						; size = 4
_len$ = -1340						; size = 4
_huff$ = -1336						; size = 4
_nMax$ = -1332						; size = 4
_used$ = -1328						; size = 4
tv885 = -1324						; size = 4
_nResult$ = -1320					; size = 4
_extra$ = -1316						; size = 4
_base$ = -1312						; size = 4
_end$ = -1308						; size = 4
_next$ = -1304						; size = 4
tv420 = -1300						; size = 4
_curr$ = -1296						; size = 4
_low$ = -1292						; size = 4
tv472 = -1288						; size = 4
_mask$ = -1284						; size = 4
_Count$ = -1280						; size = 64
_Offsets$ = -1216					; size = 64
_Work$ = -1152						; size = 1152
_type$ = 8						; size = 4
_lens$ = 12						; size = 4
_codes$ = 16						; size = 4
_table$ = 20						; size = 4
_bits$ = 24						; size = 4

.code

align 16
?inflate_table@@YGHW4codetype@@PBHHPAPAUcode@@PAH@Z PROC NEAR
	sub	esp, 1352
	push	ebx
	push	ebp
	push	edi

	xor	eax, eax
	mov	_nResult$[esp+1364], eax
	mov	ebp, _type$[esp+1360]

	; clear out our main working buffers	
	mov	ecx, 288
	lea	edi, _Work$[esp+1364]
	rep stosd

	mov	ecx, (Z_MAXBITS + 1)
	lea	edi, _Count$[esp+1364]
	rep stosd

	mov	ecx, (Z_MAXBITS + 1)
	lea	edi, _Offsets$[esp+1364]
	rep stosd

	; see what 'type' of CODE_TABLE we are building
	; type = CODE_TABLE_CODES
	test	ebp, ebp
	jne	SHORT $L55234

	lea	ecx, _Work$[esp+1364]
	mov	eax, 19
	mov	edx, ecx
	jmp	SHORT $L55237

$L55234:
	cmp	ebp, CODE_TABLE_LENS
	jne	SHORT $L55236

	mov	eax, 256
	mov	ecx, offset flat:_lbase
	mov	edx, offset flat:_lext
	sub	ecx, 1028
	sub	edx, 1028	
	jmp	SHORT $L55237

$L55236:
	; type = CODE_TABLE_DISTS
	mov	eax, -1
	mov	ecx, offset flat:_dbase
	mov	edx, offset flat:_dext

$L55237:
	; save the addresses of our arrays into stack vars
	mov	_end$[esp+1364], eax
	mov	_base$[esp+1364], ecx
	mov	_extra$[esp+1364], edx

	mov	ebp, _codes$[esp+1360]
	mov	eax, _lens$[esp+1360]
	xor	ecx, ecx

align 4
$L55239:
	mov	edx, [eax+ecx*4]
	add	DWORD PTR _Count$[esp+edx*4+1364], 1
	add	ecx, 1
	cmp	ecx, ebp
	jl	SHORT $L55239

	mov	edx, Z_MAXBITS

$L55243:
	cmp	DWORD PTR _Count$[esp+edx*4+1364], 0
	jne	SHORT $L55360
	sub	edx, 1
	cmp	edx, 1
	jge	SHORT $L55243

$L55360:
	mov	ecx, _bits$[esp+1360]
	mov	_nMax$[esp+1364], edx
	mov	edi, 1
	mov	ecx, [ecx]

align 4
$L55247:
	cmp	DWORD PTR _Count$[esp+edi*4+1364], 0
	jne	SHORT @F
	
	add	edi, 1
	cmp	edi, edx
	jle	SHORT $L55247

@@:
	cmp	ecx, edx
	jle	SHORT @F
	mov	ecx, edx

@@:
	cmp	ecx, edi
	jge	SHORT @F
	mov	ecx, edi

@@:
	mov	eax, _type$[esp+1360]
	mov	_root$[esp+1364], ecx
	mov	_curr$[esp+1364], ecx
	
	mov	ebx, 1
	shl	ebx, cl
	
	cmp	eax, CODE_TABLE_LENS
	mov	_used$[esp+1364], ebx
	jne	SHORT $L55253

	cmp	ebx, (Z_ENOUGH - Z_MAXD)
	jl	SHORT $L55253

	pop	edi
	pop	ebp
	pop	ebx
	add	esp, 1352
	ret	20

align 4
$L55253:
	push	esi
	mov	esi, 1
	mov	edx, 4
	

$L55256:
	add	esi, esi
	sub	esi, _Count$[esp+edx+1368]
	js	$L55353

	add	edx, 4
	cmp	edx, (Z_MAXBITS * 4)
	jg	SHORT $L55261

	test	esi, esi
	jg	SHORT $L55256
	jmp	SHORT $L55358

$L55261:
	test	esi, esi
	jle	SHORT $L55358

	test	eax, eax
	je	$L55353

	mov	edx, ebp
	sub	edx, _Count$[esp+1368]
	cmp	edx, 1
	jne	$L55353

$L55358:
	xor	eax, eax

align 4
@@:
	mov	edx, DWORD PTR _Count$[esp+eax+1372]
	add	edx, DWORD PTR _Offsets$[esp+eax+1372]
	add	eax, 4
	cmp	eax, ((Z_MAXBITS-1) * 4)	; zero based 
	mov	DWORD PTR _Offsets$[esp+eax+1372], edx
	jl	SHORT @B

	mov	ecx, _lens$[esp+1364]
	xor	eax, eax

align 4
$L55268:
	mov	edx, [ecx+eax*4]
	test	edx, edx
	je	SHORT @F

	mov	esi, _Offsets$[esp+edx*4+1368]
	lea	edx, _Offsets$[esp+edx*4+1368]
	mov	_Work$[esp+esi*4+1368], eax
	add	esi, 1
	mov	[edx], esi

@@:
	add	eax, 1
	cmp	eax, ebp
	jl	SHORT $L55268
	
	mov	eax, _table$[esp+1364]
	mov	DWORD PTR _huff$[esp+1368], 0
	mov	DWORD PTR _drop$[esp+1368], 0
	mov	eax, [eax]
	add	ebx, -1
	lea	ecx, _Work$[esp+1368]
	mov	DWORD PTR _low$[esp+1368], -1
	mov	_len$[esp+1368], edi
	mov	tv885[esp+1368], ecx
	mov	tv420[esp+1368], eax
	mov	_next$[esp+1368], eax
	mov	_mask$[esp+1368], ebx

align 4
$L55275:
	mov	ebp, 1
	mov	ecx, _curr$[esp+1368]
	mov	edx, _len$[esp+1368]
	mov	eax, tv885[esp+1368]
	shl	ebp, cl
	sub	edx, _drop$[esp+1368]
	mov	ecx, [eax]
	mov	dword ptr _c$[esp+1368], 0
	mov	eax, _end$[esp+1368]
	mov	BYTE PTR _c$[esp+1369], dl
	cmp	ecx, eax
	jge	SHORT @F

	mov	WORD PTR _c$[esp+1370], cx
	jmp	SHORT $L55363
	
@@:
	jle	SHORT @F

	mov	eax, _extra$[esp+1368]
	mov	ebx, _base$[esp+1368]
	mov	al, byte ptr [eax+ecx*4]
	mov	bx, word ptr [ebx+ecx*4]
	mov	byte ptr _c$[esp+1368], al
	mov	word ptr _c$[esp+1370], bx
	jmp	SHORT $L55363
	
@@:
	mov	BYTE PTR _c$[esp+1368], 96
	
$L55363:
	mov	ecx, edx
	mov	esi, 1
	mov	edi, _huff$[esp+1368]
	shl	esi, cl
	mov	ecx, _drop$[esp+1368]
	mov	ebx, ebp
	shr	edi, cl
	mov	eax, _next$[esp+1368]
	add	edi, ebp
	lea	ecx, [eax+edi*4]
	mov	edi, _c$[esp+1368]
	lea	eax, [esi*4]

@@:
	sub	ebx, esi
	sub	ecx, eax

	test	ebx, ebx
	mov	[ecx], edi
	ja	SHORT @B
	
	mov	edi, _len$[esp+1368]
	mov	esi, 1
	mov	eax, _huff$[esp+1368]
	lea	ecx, [edi-1]
	shl	esi, cl
	test	esi, eax
	je	SHORT $L55301

@@:
	shr	esi, 1
	test	esi, eax
	jne	SHORT @B

$L55301:
	test	esi, esi
	je	SHORT @F

	lea	ecx, [esi-1]
	and	ecx, eax
	add	ecx, esi
	mov	_huff$[esp+1368], ecx
	jmp	SHORT $L55303

@@:
	mov	_huff$[esp+1368], esi
	
$L55303:
	add	DWORD PTR tv885[esp+1368], 4
	add	DWORD PTR _Count$[esp+edi*4+1368], -1
	jne	SHORT $L55304

	cmp	edi, _nMax$[esp+1368]
	je	$L55356

	mov	edx, tv885[esp+1368]
	mov	eax, [edx]
	mov	ecx, _lens$[esp+1364]
	mov	edx, [ecx+eax*4]
	mov	_len$[esp+1368], edx
	sub	edx, _drop$[esp+1368]
	mov	edi, _len$[esp+1368]

$L55304:
	cmp	edi, _root$[esp+1368]
	jle	$L55275

	mov	edi, _mask$[esp+1368]
	and	edi, _huff$[esp+1368]
	cmp	edi, _low$[esp+1368]
	mov	tv472[esp+1368], edi
	je	$L55275
	
	cmp	DWORD PTR _drop$[esp+1368], 0
	mov	ebx, _root$[esp+1368]
	jne	SHORT $L55308

	mov	edx, _len$[esp+1368]
	mov	_drop$[esp+1368], ebx
	sub	edx, ebx

$L55308:
	mov	eax, _next$[esp+1368]
	mov	ecx, edx
	mov	esi, 1
	shl	esi, cl
	lea	ebp, [eax+ebp*4]
	mov	ecx, _drop$[esp+1368]
	mov	eax, _nMax$[esp+1368]
	add	ecx, edx
	cmp	ecx, eax
	mov	_next$[esp+1368], ebp
	jge	SHORT $L55346
	lea	edi, _Count$[esp+ecx*4+1368]

$L55310:
	sub	esi, [edi]
	test	esi, esi
	jle	SHORT $L55357

	add	ecx, 1
	add	edx, 1
	add	edi, 4
	add	esi, esi
	cmp	ecx, eax
	jl	SHORT $L55310

$L55357:
	mov	edi, tv472[esp+1368]

$L55346:
	mov	ecx, edx
	mov	esi, 1
	shl	esi, cl
	mov	eax, 1

	add	_used$[esp+1368], esi
	cmp	_type$[esp+1364], eax
	jne	SHORT $L55313
	cmp	DWORD PTR _used$[esp+1368], 1286
	jge	SHORT $L55276
	
$L55313:
	mov	esi, tv420[esp+1368]
	mov	eax, edi
	lea	ecx, [esi+eax*4]
	mov	BYTE PTR [ecx], dl
	add	ecx, 1
	sub	ebp, esi
	sar	ebp, 2
	mov	BYTE PTR [ecx], bl
	mov	_low$[esp+1368], eax
	mov	WORD PTR [ecx+1], bp
	mov	_curr$[esp+1368], edx
	jmp	$L55275

align 4
$L55356:
	mov	eax, _nResult$[esp+1368]
	mov	ebx, _root$[esp+1368]

$L55276:
	mov	ecx, _used$[esp+1368]
	mov	edx, tv420[esp+1368]
	lea	edx, [edx+ecx*4]
	mov	ecx, _table$[esp+1364]
	pop	esi
	pop	edi
	mov	[ecx], edx
	mov	edx, _bits$[esp+1356]
	pop	ebp
	mov	[edx], ebx
	pop	ebx
	add	esp, 1352
	ret	20

align 4
$L55353:
	mov	eax, _nResult$[esp+1368]
	pop	esi
	pop	edi
	pop	ebp

$FINISHED$55254:
	pop	ebx
	add	esp, 1352

	ret	20
?inflate_table@@YGHW4codetype@@PBHHPAPAUcode@@PAH@Z ENDP
_TEXT	ENDS

END
