// ---------------------------------------------------------------------------
// Menu.h
// ===========================================================================
#if !defined(AFX_ASM_MENU_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_)
#define AFX_ASM_MENU_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#if defined(__cplusplus)
extern "C" {
#endif

    // UNICODE ASM prototypes
    void __stdcall CreateMenuDataW(IN HMENU hMenu, IN BOOL bMainMenu, IN HFONT hFont);
    void __stdcall DrawMenuItemW(IN LPDRAWITEMSTRUCT lpms, IN LPVOID lpImageStates);


    // ANSI ASM prototypes
    void __stdcall CreateMenuDataA(IN HMENU hMenu, IN BOOL bMainMenu, IN HFONT hFont);
    void __stdcall DrawMenuItemA(IN LPDRAWITEMSTRUCT lpms, IN LPVOID lpImageStates);


    // Generic ASM prototypes
    void __stdcall DeleteMenuItemData(IN HMENU hMenu);
    int  __stdcall GetMenuBarTextWidth(IN HMENU hMenu);
    void __stdcall MeasureMenuItem(IN LPMEASUREITEMSTRUCT lpms);


    // Generic defines to allow a single name to cover both types
#if defined(_UNICODE)
    #define CreateMenuData      CreateMenuDataW
    #define DrawMenuItem        DrawMenuItemW
#else
    #define CreateMenuData      CreateMenuDataA
    #define DrawMenuItem        DrawMenuItemA
#endif


#if defined(__cplusplus)
}
#endif

// ===========================================================================
#endif // #define AFX_ASM_MENU_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_
