; ----------------------------------------------------------------------------
; structures
; ----------------------------------------------------------------------------
MenuItem struct
    hFont           dword ?
    bMainMenu       dword ?
    csSize          SIZEL<>
    cchItemText     DWORD ?
    szItemText      DWORD ?
MenuItem ends

MenuSingleItemState struct
    bmImage     dword ?
    csImage     SIZEL<>
MenuSingleItemState ends

MenuItemsState struct
    Default     MenuSingleItemState<>
    Hover       MenuSingleItemState<>
    Selected    MenuSingleItemState<>
MenuItemsState ends


; ----------------------------------------------------------------------------
; externed function call identifiers
; ----------------------------------------------------------------------------
externdef stdcall DeleteMenuItemData    :proto stdcall :dword
externdef stdcall GetMenuBarTextWidth   :proto stdcall :dword
externdef stdcall MeasureMenuItem       :proto stdcall :dword

externdef stdcall CreateMenuDataA       :proto stdcall :dword, :dword, :dword
externdef stdcall CreateMenuDataW       :proto stdcall :dword, :dword, :dword
externdef stdcall DrawMenuItemA         :proto stdcall :dword, :dword
externdef stdcall DrawMenuItemW         :proto stdcall :dword, :dword


; ----------------------------------------------------------------------------
; Function definitions used in the owner drawn menu --- ANSI or UNICODE based
; on define during assembling
; ============================================================================
IF _UNICODE eq 1	; same definition as the MFC library (windows API uses UNICODE)
    CreateMenuData      equ <CreateMenuDataW>
    DrawMenuItem        equ <DrawMenuItemW>
ELSE
    CreateMenuData      equ <CreateMenuDataA>
    DrawMenuItem        equ <DrawMenuItemA>
ENDIF

