@ECHO OFF

REM ---------------------------------------------------------
REM  Clean the .OBJ and .SBR files from the DebugU directory.
REM ---------------------------------------------------------
IF EXIST DebugU\*.obj @ECHO Cleaning .obj files from the DebugU directory
IF EXIST DebugU\*.obj DEL DebugU\*.obj
IF EXIST DebugU\*.sbr @ECHO Cleaning .sbr files from the DebugU directory
IF EXIST DebugU\*.sbr DEL DebugU\*.sbr

REM ----------------------------------------------------
REM  Build the UNICODE debug code version of the ASM files.
REM --------------------------------------------------
CD DebugU
IF EXIST ..\*.asm @CALL \asm\du.bat ..\*
IF EXIST ..\UNICODE\*.asm @CALL \asm\du.bat ..\UNICODE\*

IF EXIST *.obj \masm32\bin\polib.exe /out:%1.lib *.obj 

REM ----------------------------------------------------
REM  Change back to the starting directory where this
REM  batch from was called from to keep our directory
REM  navigation in tack in case other batch files will
REM  be called.
REM ----------------------------------------------------
CD ..

@ECHO.