// ---------------------------------------------------------------------------
// asm_Memory.h
// ===========================================================================
#if !defined(AFX_ASM_MEMORY_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_)
#define AFX_ASM_MEMORY_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#if defined(__cplusplus)
extern "C" {
#endif

// ANSI and UNICODE ASM prototypes
    HANDLE  __stdcall fmInitialize();
    void    __stdcall fmCopy(LPVOID pDest, LPCVOID pSrc, const size_t dwSize);
    void    __stdcall fmClear(IN LPVOID pAddr, IN const size_t dwSize);
    LPVOID  __stdcall fmAlloc(IN const size_t size);
    void    __stdcall fmFree(IN LPCVOID pAddr);
    LPVOID  __stdcall fmResize(IN LPCVOID pAddr, IN const size_t nNewSize);


// UNICODE ASM prototypes



// ANSI ASM prototypes



// Generic defines to allow a single name to cover both types
#if defined(_UNICODE)
    //
#else
    //
#endif



#if defined(__cplusplus)
}
#endif


// ===========================================================================
#endif // #define AFX_ASM_MEMORY_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_
