// ---------------------------------------------------------------------------
// asm_Wnd.h
// ===========================================================================
#ifndef __ASM_WND_H__
#define __ASM_WND_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef __cplusplus
extern "C" {
#endif

// ANSI and UNICODE ASM prototypes
    void    __stdcall InitWin32Controls();


// UNICODE ASM prototypes
    ATOM    __stdcall RegClassW(const HINSTANCE hInst, const HICON hIcon, const HCURSOR hCursor, const wchar_t* className, WNDPROC wndProc);
    LRESULT __stdcall MsgLoopW(const HWND hWnd);
    LRESULT __stdcall MsgLoopWAccelW(const HWND hWnd, const HINSTANCE hInst, const wchar_t* AccelID);

// ANSI ASM prototypes
    ATOM    __stdcall RegClassA(const HINSTANCE hInst, const HICON hIcon, const HCURSOR hCursor, const CHAR* className, WNDPROC wndProc);
    LRESULT __stdcall MsgLoopA(const HWND hWnd);
    LRESULT __stdcall MsgLoopWAccelA(const HWND hWnd, const HINSTANCE hInst, const CHAR* AccelID);


	// Generic defines to allow a single name to cover both types
#if defined(_UNICODE)
    #define RegClass        RegClassW
    #define MsgLoop         MsgLoopW
    #define MsgLoopWAccel   MsgLoopWAccelW
#else
    #define RegClass        RegClassA
    #define MsgLoop         MsgLoopA
    #define MsgLoopWAccel   MsgLoopWAccelA
#endif


#ifdef __cplusplus
}
#endif

// ===========================================================================
#endif // #define __ASM_WND_H__

