TITLE "Base procedure for calling the Win32 CreateFile API"

.486
.model flat				; memory model
option casemap:none	; case sensitive

include kernel32.inc

.code

align 16
; ----------------------------------------------------------------------------
; prototype:
;   void __stdcall fileClose(HANDLE* hFile);
;
; description:
;
; returns:
; ============================================================================
_fileClose@4 PROC NEAR
	; get the file handle into the register to work with
	push ebx
	mov ebx, [esp + 8]
	
	; close the file handle if it is a valid handle
	cmp dword ptr [ebx], INVALID_HANDLE_VALUE
	je @F
	
	; close it
	push [ebx]
	call CloseHandle
	
	; set the handle value to invalid
	mov dword ptr [ebx], INVALID_HANDLE_VALUE

@@:
	pop ebx
	ret 4	
_fileClose@4 ENDP

END
