@ECHO OFF

REM -------------------------------------------------------------------
REM  Change to the correct directory to assemble the library files
REM -------------------------------------------------------------------
CD OwnerDrawn\%1

@ECHO -------------------------------------------------------------------
@ECHO  Building ASM files for library: %1
@ECHO -------------------------------------------------------------------

REM -------------------------------------------------------------------
REM  Removing the following four library files from the LIB directory.
REM -------------------------------------------------------------------
FOR %%x IN (ad, ar, ud, ur) DO IF EXIST \asm\lib\%1%%x.lib DEL \asm\lib\%1%%x.lib

REM -------------------------------------------------------------------
REM  Assemble the ANSI and UNICODE .asm files (both DEBUG and RELEASE
REM  code). Once all the files are assembled, build the new libraries.
REM -------------------------------------------------------------------
FOR %%x IN (ad, ar, ud, ur) DO @CALL \asm\do-%%x.bat \asm\lib\%1%%x

REM -------------------------------------------------------------------
REM  Return back to the ASM directory when done with this batch file
REM -------------------------------------------------------------------
CD \ASM

@ECHO.