@ECHO OFF
CLS

@ECHO Assembling all the library .asm files and creating .lib files

REM ---------------------------------------------------------------------
REM  Change to the ASM source directory to start building the .ASM files
REM ---------------------------------------------------------------------
@CD \ASM


REM ---------------------------------------------------------------------
REM  Remove any previous build log file
REM ---------------------------------------------------------------------
IF EXIST build.log DEL build.log


REM ---------------------------------------------------------------------
REM  Assemble each of the library files
REM ---------------------------------------------------------------------
FOR %%x IN (analysis, array, datetime, inet) DO @CALL \asm\m.bat %%x >> build.log
FOR %%x IN (io, mem, misc, str, wnd) DO @CALL \asm\m.bat %%x >> build.log
FOR %%x IN (graphics, zip) DO @CALL \asm\m.bat %%x >> build.log
FOR %%x IN (menu) DO @CALL \asm\m-ownerdrawn.bat %%x >> build.log


@ECHO Building the runtime library

REM ---------------------------------------------------------------------
REM  Build the runtime library
REM ---------------------------------------------------------------------
@CALL mrtl.bat >> build.log


REM ---------------------------------------------------------------------
REM  Show the build log file
REM ---------------------------------------------------------------------
START notepad.exe build.log